// Create closure to keep namespace clean and hide implementation.
(function($) {
  $.fn.applyReverse = function(applyToClass) {
    var parent_obj = this;
    this.find('.lat').keyup(function() {
      reverse(parent_obj);
    });
    this.find('.lng').keyup(function() {
      reverse(parent_obj);
    });
  };

  $.fn.applyReverseSubmit = function(applyToClass) {
    var parent_obj = this;
    this.find(':submit').click(function() {
       reverse(parent_obj);
       return false;
    });
  };

  var pro6pp_cache = {};
  function pro6pp_cached_get(obj, url, callback) {
    if (pro6pp_cache.hasOwnProperty(url)) {
      callback(obj, pro6pp_cache[url]);
    } else {
      $.getJSON(url + "&callback=?", function(data) {
        pro6pp_cache[url] = data;
        callback(obj, data);
      });
    }
  }

  function reverse(obj) {
    $(obj).find('.message').empty();
    var lat = $(obj).find('.lat').val();
    var lng = $(obj).find('.lng').val();
    $(obj).find('.spinner').show();
    var url = "https://api.pro6pp.nl/v1/reverse?auth_key=" + pro6pp_auth_key
        + "&lat=" + lat + "&lng=" + lng;
    url = encodeURI(url);
    pro6pp_cached_get(obj, url, fillin);
  }

  function fillin(obj, json) {
    $(obj).find('.spinner').hide();
    if (json.status == 'ok') {
      var city = $(obj).find('.city');
      city.val(json.results.city);
      var municipality = $(obj).find('.municipality');
      municipality.val(json.results.municipality);
      var province = $(obj).find('.province');
      province.val(json.results.province);

      var streets = $(obj).find('.streets');
      streets.val(json.results.streets);
      var nl_sixpp = $(obj).find('.nl_sixpp');
      nl_sixpp.val(json.results.nl_sixpp);
      var lat = $(obj).find('.lat_out');
      lat.val(json.results.lat);
      var lng = $(obj).find('.lng_out');
      lng.val(json.results.lng);
      var precision = $(obj).find('.precision');
      precision.val(json.results.precision);
    } else {
      var translated_message = json.error.message;
      if (json.error.message == 'location not found') {
        translated_message = 'Onbekende locatie';
      } else if (json.error.message == 'invalid location format') {
        translated_message = 'Ongeldig formaat';
      }

      $(obj).find('.message').html(translated_message);
    }
  }
})(jQuery);
